



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>与数论的厮守02:整数的因子分解—Pollard_Rho</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">与数论的厮守02:整数的因子分解—Pollard_Rho</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-18 06:41:07 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　学Pollard_Rho之前，你需要学会：Miller Rabin。</p>
<p>　　这是一个很高效的玄学算法，用来对大整数进行因数分解。</p>
<p>　　我们来分解n。若n是一个素数，那么就不需要分解了。所以我们还得能够判断一个数是否为素数才行。而n是个大整数，显然普通的试除法和筛法都是不够它跑的。所以我们就得考虑用Miller Rabin来判断。</p>
<p>　　但n不是素数呢？这就得用Pollard_Rho了。首先我们来看一个有趣的东西：生日悖论。</p>
<p>　　生日悖论：说简单点，就是在N个数里面选k个，当k接近&radic;N时，选出两个相同数的几率约为50%。比如，不考虑闰年时，一个班若有23个人，则有两人生日相同的概率约为50%；但人数达到60时，概率约为基本上就是100%了，这严重违背了我们的生活经验，所以被列为了悖论。</p>
<p>　　模仿着生日悖论，若在1~N里面选k个数X<sub>1</sub>,X<sub>2</sub>...X<sub>K</sub>,若k足够大，则很大几率有gcd(X<sub>i</sub>-X<sub>j</sub>，N)&gt;1，也就是二者不互质，此时gcd(X<sub>i</sub>-X<sub>j</sub>，N)就是N的一个因数了。但是这样做复杂度又退回了O(k<sup>2</sup>)，处理不好还能退化为O(n<sup>2</sup>)。所以Pollard_Rho是有改进的。首先是空间。改进的Pollard_Rho只需要存相邻的两个数：X<sub>i</sub>，X<sub>i+1</sub>。同时为了得到这些数，Pollard_Rho还设计了一个函数：f(X<sub>i</sub>)=(X<sub>i</sub><sup>2</sup>+c) mod n。这个c可以rand出来。然后再计算d=gcd(|X<sub>i</sub>-X<sub>i+1</sub>|，N)，若d&gt;1，则递归分解d和n/d。<sub><br /></sub></p>
<p>　　但是mod n的值&isin;[0,n-1]之间，只有n个数，所以当递归够深时就会出现循环，这不利于我们的算法。就是这个样子(图是盗的)：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1443454/201904/1443454-20190415161735794-492909209.png" /></p>
<p>　　这里就有一个优化。像刚才的图一样，我们可以把循环节看成是一个环，我们只需要找出环就可以停下了。不然就一直跑到递归的数为素数为止。怎么找环呢？我们会想一下小学的追及问题。假设跑道上有两个人，一个高个子和一个矮个子。矮个子的速度为1，高个子的速度为2。如果跑道是无限长的直线，那高个子就会永远跑在矮个子前面。但如果有环，那么高个子就肯定追得到矮个子。Pollard_Rho就可以用这个办法来找环。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1443454/201904/1443454-20190415163807030-383330310.png" /></p>
<p>(这个图也是盗的)</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k5z7r8.html">使用VMware Workstation 12&period;5&period;2新建虚拟机</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93746n8.html">SpringMVC接收页面表单参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j4ozw9.html">Qt 自定义 滚动条 样式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn0o3pq.html">Codeforces Round &num;272 &lpar;Div&period; 1&rpar; Problem C&period; Dreamoon and Strings</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdox3d8.html">Linux 环境变量和source命令 （转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1krno69.html">【欧拉计划4】Largest palindrome product</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzn31l8.html">Mac下安装cscope和ctags</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyj5nj9.html">Docker - 访问仓库</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kdz229.html">自定义spring mvc的json视图</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1lojoq.html">在Ubuntu 18&period;04系统上安装Systemback的方法（抄）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95041w68.html">基础环境系列：PHP7&period;3&period;0并连接pache&sol;IIS和MySQL</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2m20pq.html">HDU 3565 Bi-peak Number（数位DP）题解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rkrm28.html">mybatis 映射生成mapper和pojo ---逆向工程的使用过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j4rd3q.html">洛谷 P5020 【货币系统】</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2rjzrq.html">python&comma;opencv&comma;imread&comma;imwrite&comma;存储，读取图像像素不一致，这种情况是label使用jpg格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4r0re9.html">Collection中的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllx410q.html">C语句详细（初学者）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jrk75q.html">windows 激活venv问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnzkorq.html">3、class文件加载过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyv1yzjq.html">chrome ui源码剖析-Accelerator&lpar;快捷键&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q252p1wq.html">Odoo 进销存报表现已开源</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1gzkeq.html">PDFBOX详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jkx20q.html">pytest学习 一</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxd51gz9.html">5&period;动态代理AOP实现-DynamicProxy模式</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pw31kk8.html">elasticsearch以及head插件在centos7上的安装与配置教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r51j64q.html">jsp 连接access数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7ogprg8.html">Linux （OpenBSD）系统目录分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4wedx9.html">让mysql 支持 emoji 表情</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e4w1dx9.html">Qt自定义控件大全&plus;designer源码</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2k206q.html">在php cli下可以使用 STDIN 来实现标准输入</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
